import java.io.*;
import java.util.*;



public class sol_vasilyeva {
	static BufferedReader br;
	static StringTokenizer st;
	static PrintWriter out;


	public void solve(){
		int N, K, M;
		int[] ans;
		int[] c;
		int[] mod;
		N = nextInt();
		K = nextInt();
		M = nextInt();
		c = new int[N + 1];
		ans = new int[N + 1];
		mod = new int[2 * M + 1];
		for (int i = 1; i < N + 1; ++i){
			int tmp = nextInt();
			c[i] = M - tmp % M;
		}
		for (int i = 0; i < M; ++i)
			mod[i] = mod[M + i] = i;
		for (int i = 1; i <= N; ++i)
			ans[i] = -1;
		for (int i = 0; i < N; ++i){
			int buff = 0;
			int m = Math.min(i + K, N);
			for (int j = i + 1; j <= m; ++j){
				buff = mod[(buff + c[j])];
			ans[j] = ans[j] != -1 ? Math.min(ans[j], ans[i] + buff) : ans[i] + buff;
			}
		}
		out.print(ans[N]);
	}

	
	public void run() {
		try {
			br = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	
	String nextToken() {
		try {
			while (st == null || !st.hasMoreTokens()) {
				String s = br.readLine();
				if (s == null) {
					return null;
				}
				st = new StringTokenizer(s);
			}
			return st.nextToken();
		} catch (IOException e) {
			throw new RuntimeException();
		}
	}

	
	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	
	public static void main(String[] args) {
		try {
			new sol_vasilyeva().run();
		} catch (Exception exept) {
			exept.printStackTrace();
			System.exit(216);
		}
	}
}
