#include <stdio.h>
#include <iostream>
#include <string>
#include <vector>
#include <math.h>


using namespace std;


typedef vector<int> VI;


const int MaxN = 40*1000;
const int MaxM = 10*1000;
const int MaxK = 2000;
const int MaxCost = 1000*1000;


VI cost;
VI dyn;
int n, m, k;


inline void my_assert(bool cond, const string& msg) {
	if (!cond) {
		cerr << "WRONG INPUT : ";
		cerr << msg << endl;		
		throw msg;
	}
}


int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	scanf("%d%d%d", &n, &k, &m);
	my_assert(0 < n && n <= MaxN, "Wrong N value");
	my_assert(0 < k && k <= MaxK, "Wrong K value");
	my_assert(0 < m && m <= MaxM, "Wrong M value");
	cost.resize(n+1);
	int tmp;
	for (int i = 1; i <= n; i++) {
		scanf("%d", &tmp);
		my_assert(0 < tmp && tmp <= MaxCost, "Wrong one of cost values");
		cost[i] = m - tmp % m;
	}

	dyn.resize(n+1);
	for (VI::iterator it = ++dyn.begin(); it < dyn.end(); it++) {
		*it = -1;
	}
	for (int i = 0; i < n; i++) {
		int buff = 0;
		int max_ind = min(i+k, n);
		for (int j = i+1; j <= max_ind; j++) {
			buff = (buff + cost[j]) % m;
			dyn[j] = dyn[j] != -1 ? min(dyn[j], dyn[i] + buff) : dyn[i] + buff;
		}
	}
	cout << dyn[n];
	fclose(stdin);
	fclose(stdout);
}
